<?php
namespace Bitfoundry\Etnpay\Block\Payment;

class Info extends \Magento\Payment\Block\Info
{
    protected $_EtnpayInfoFactory;

    /**
     * @param \Magento\Framework\View\Element\Template\Context $context
     * @param \Magento\Payment\Model\Config $paymentConfig
     * @param \Bitfoundry\Etnpay\Model\InfoFactory $EtnpayInfoFactory
     * @param array $data
     */
    public function __construct(
        \Magento\Framework\View\Element\Template\Context $context,
        \Magento\Payment\Model\Config $paymentConfig,
        \Bitfoundry\Etnpay\Model\InfoFactory $EtnpayInfoFactory,
        array $data = []
    ) {
        $this->_EtnpayInfoFactory = $EtnpayInfoFactory;
        parent::__construct( $context, $data );
    }
    
    protected function _prepareSpecificInformation($transport = null)
    {
        $transport = parent::_prepareSpecificInformation($transport);
        $payment = $this->getInfo();
        $etnpayInfo = $this->_EtnpayInfoFactory->create();
        $info = $etnpayInfo->getPaymentInfo($payment, true);

        return $transport->addData($info);
    }
}
