<?php
namespace Bitfoundry\Etnpay\Controller\Scan;

use Magento\Framework\App\Action\Action;

class Failure extends Action
{
    protected $resultPageFactory;
    protected $_messageManager;
    protected $orderManagement;

    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Magento\Framework\View\Result\LayoutFactory $resultLayoutFactory,
        \Magento\Checkout\Model\Session $checkoutSession,
        \Magento\Framework\Message\ManagerInterface $messageManager
    )
    {
        parent::__construct($context);
        $this->_resultLayoutFactory     = $resultLayoutFactory;
        $this->_checkoutSession         = $checkoutSession;
        $this->messageManager           = $messageManager;
    }

    public function execute()
    {
        $this->_order = $this->_checkoutSession->getLastRealOrder();

        $message = __('Electroneum payment failed.');
        if ($this->_order->getId() && $this->_order->getState() != \Magento\Sales\Model\Order::STATE_CANCELED) {
            $this->_order->registerCancellation($message)->save();
        }
        $this->_checkoutSession->restoreQuote();

        $this->messageManager->addWarningMessage($message);
        $this->_redirect('checkout/cart', array('_secure'=> true));

        return '';
    }
}
